//+-------------------------------------------------------------------+
//|                                                           FPI.mq4 |
//|                                 Copyright (C) Nov 2006, by Bitchy |
//| THE BEER-WARE LICENSE:  As long as you retain this notice you can |
//| do whatever you want with this stuff. If we meet some day, and if |
//| you think this stuff is worth it, you can buy me a beer in return.|
//|                                                                   |
//| THE EXPERT/INDICATOR:                                             |
//| It is obvious that working with two curencies only, will lead to  |
//| no profit, but just to pay the spread two times. Working with     |
//| more that 3 curencyes will result in paying higher comission too, |
//| that is why I decided to work with 3 curencies resulting in 3     |
//| curency-pairs only. The ring formed by 3 curency pairs seems to   |
//| be optimum for spreads and movements of the indicator. I did also |
//| tests for larger rings, and the results are worse, for example    |
//| for a ring with 4 pairs you pay 4 times the spread, so you need   |
//| to wait longer, or wait for larger movement of the indicator to   |
//  be able to breakeven. I use here "EURUSD", "GBPUSD", and "EURGBP" |
//| because they are the most worthy (high pay per pip, volatile,     |
//| and a good volume transactions everyday), but you can change the  |
//| pairs by changing the parameters of the indicator. The program    |
//| assume that the pairs are corect and won't make any foolproof     |
//| tests, so if you write JPYUSD instead of USDJPY, it won't work).  |
//| Also you must pay attention to keep the relation as in            |
//| E/U -> G/U -> E/G, (I mean X/Y -> Z/Y -> X/Z) otherwise you have  |
//| to change the BSS/SBB rings in start() function (the part that    |
//| operates with the spread and mutiplication/division)              |
//+-------------------------------------------------------------------+
#property copyright "Copyright (C) Nov 2006, by Bitchy"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Gold
#property indicator_minimum 0.98
#property indicator_maximum 1.02
#property indicator_level1  1.0

//---- buffers
double ExtMapBuffer1[];

//---- parameters
extern string MainPair="EURUSD";  //the main pair in the ring, this is 
  //the pair that is open on the chart where the indicator is added 
  //and where the ProfitLine is drawn (see below). If you use Mini Account
  //on InterbankFX broker or another as that one, then you have to add 
  //an "m" to the end of the names, as EURUSDm, GBPUSDm, and EURGBPm, 
  //this you can do when set external parameters, no need to modify the 
  //program source here
extern string SecondPair ="GBPUSD"; //second pair on the ring
extern string ThirdPair  ="EURGBP"; //and the third pair
extern int    TimeFrame  = 1;       //this is the timeframe in minutes
  //when the indicator is computed, see below note about Open price. 
  //This alow to open a timeframe of i.e. M30 and add the indicator to
  //it, but the indicator will not be calculated on the current TF, 
  //but on a more accurate one with higher resolution. To see the 
  //indicator on real Open price only, one must open a chart with 
  //the same TF as TimeFrame and add the indicator to it. 
extern bool   ReverseRing = false; //play the rings in reverse direction
  //this is for folks that will see the equity graph going down and
  //down on the EA, and will start complaining that we play the rings
  //in the wrong direction. If you change the rings direction, you will
  //get probably the same bad result :D (I just assume, can not try out
  //until I finish the implementation of EA, but is worth trying, I wish
  //for you guys, that I could be wrong...)

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
//----
// We create a trendline that can be moved with the mouse around the chart 
// and it will show us the potential profit as a comment on the main screen 
// on the upper right corner. In this case we can decide which direction for
// the ring we will take and when. The indicator is only considering the 
// open price, for the reason we will discuss below. 
   ObjectCreate("ProfitLine",OBJ_TREND,0,CurTime()-30*Period()*30,Open[30],CurTime(),Open[0]);
   ObjectSet("ProfitLine",OBJPROP_RAY,false);
   ObjectSet("ProfitLine",OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet("ProfitLine",OBJPROP_BACK,false);
   ObjectSet("ProfitLine",OBJPROP_COLOR,Gold);
   ObjectSet("ProfitLine",OBJPROP_WIDTH,3);
//there is also a green/blue dot at the beginning of the line, and a red dot at 
//the end of the line, just to show us the right direction of the bet, for the  
//case when our mouse get crazy and we revert the line by mistake (as dragging 
//the end of the line in the left side of the beginning of the line, in this 
//case we will see in the comment the profit for a trade that goes backwards
//in time (as open the trade today, and close it yesterday :D)
   ObjectCreate("GrnDot",OBJ_ARROW,0,CurTime()-30*Period()*30,Open[30]);
   ObjectCreate("RedDot",OBJ_ARROW,0,CurTime(),Open[0]);
       //depending on your zoom and vertical magnification of the chart, 
       //could be that the circles are not centered with the ends of the line,
       //need more work to read the magnification, font size, zoom, etc to
       //center the circles, and is not worth to do it, this is not important
       //issue, I won't spend time for it. Note that there is not any way
       //to connect two or more objects together, so the circles can be dragged
       //alone, but they will folow the line ends as soon as the line is moved
       //and/or new tick is comming
   ObjectSet("GrnDot",OBJPROP_COLOR,Blue);
   ObjectSet("RedDot",OBJPROP_COLOR,Red);
   ObjectSet("GrnDot",OBJPROP_ARROWCODE,164);
   ObjectSet("RedDot",OBJPROP_ARROWCODE,164);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- just to get rid of the trendline when the indicator is removed
   ObjectDelete("ProfitLine");
   ObjectDelete("GrnDot");
   ObjectDelete("RedDot");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- the last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars-5;

//remove the two slashes in front of the next line if initialization 
//takes too long, to limit the number of bars used to compute the indicator

//   if (limit>300) limit=300; //think 300 bars on the bigger timeframe 
          //(the curent visible chart) are enough, and we can get the
          //initialization faster in this way, too. Note that you will 
          //not see the indicator for all 300 bars if you don't have
          //the history with TF=TimeFrame (here M1, that is usually much
          //newer in time). To see all the indicator in the past, you 
          //have to download the history, or increase TimeFrame up to the 
          //current TimeFrame (M30). If the history is not present, it is
          //also possible that the indicator is not accurate in the 
          //beginning (all uper the 1.00 or all lower the 1.00 as the charts
          //are shifted for the smallest timeframe)

//---- main loop

//for all the bars except the last one, we compute the indicator only for
//open price of the bar. This is because the history charts do not store 
//the ticks, but only the OHLCV prices, and the Strategy Tester is doing 
//FRACTAL INTERPOLATION for the "interior" of each bar. This means that 
//if we consider three charts on three pairs on the same time frame,
//at a PRECISELY given moment of time, there will be three different 
//interpolations of the prices involved, and all will be eventualy 
//different from the real prices at THAT given quantum of time. For example
//if you interpolate a bar, to get the movement of the bid/ask "inside"
//of the bar, the interpolation algoritm can go from open to high then to
//low, then to close, or it can go from open to low, then to high then to
//close, or eventualy it'll have many oscilations high/low depending
//on the Volume of the bar. This price oscillation is not the real price 
//oscilation and can lead to wrong results and false positives for our 
//indicator. We are talking here of 0.00001 differences to the median
//line of 1.0, and a wrong price with ONLY one pip can bring a very
//unexpected result, expecially if we use high time frames, for example
//for E/U and G/U M30, let's say we have a bar starting at 15:00 o'clock and 
//finishing at 15:30, if we look for the price at 15:25:47, in real time 
//both prices could be at the lowest point of the bars, but for backtesting
//it could happend (because of interpolation and different volumes of the 
//respective bar in the two charts) that E/U price is in the middle of
//the bar, and G/U price is at the top of the bar. The only prices on 
//the history charts that match the real price for a given arbitrary time
//is the Open price of each bar, that is a "momentum 0" of the bar. That 
//is why this strategy can not be backtested, as somebody said on the 
//forum already, unless you have a REAL TICK CHART for all the pairs, with 
//REAL bid/ask spread for all ticks and all period of testing. This charts
//do not exist, will be HUUUUUGEEEEE (you need many gigabytes to store 
//only some weeks of chart). That is why I said this strategy looks nice
//when tested against history charts, it produce a lot of nice signals
//and a lot of profits on false positive signals derived from the 
//interpolation of the bars, that won't happen in real time. 
   double AccurateShift=limit*Period()/TimeFrame;
   for(int shift=MathFloor(AccurateShift); shift>0; shift--)
   { //dealing with the history
     double open1=iOpen(MainPair,TimeFrame,shift);
     double open2=iOpen(SecondPair,TimeFrame,shift);
     double open3=iOpen(ThirdPair,TimeFrame,shift);
     if (open1==0 || open2==0 || open3==0)
     { Alert("OOOOPPPSSS! History missing!",
             "\n  TimeFrame   = ",TimeFrame,
             "\n  Shift       = ",shift,
             "\n  Bar1 Time   = ",TimeToStr(iTime(MainPair,TimeFrame,shift)),
             "\n  ",MainPair," open = ",open1,
             "\n  Bar2 Time   = ",TimeToStr(iTime(SecondPair,TimeFrame,shift)),
             "\n  ",SecondPair," open = ",open2,
             "\n  Bar3 Time   = ",TimeToStr(iTime(MainPair,TimeFrame,shift)),
             "\n  ",ThirdPair," open = ",open3);
       //you should have all the history for the TF=TimeFrame for the 
       //period of current timeframe history. For example if you use M30
       //as current chart and you have n=300 bars on it and you use M1 as 
       //TimeFrame parameter for calculation at every minute, you should 
       //have in M1 chart history at least n*Period()/Timeframe bars,
       //this is for the current example 30*300=9000 bars in M1 history (!)
       //To see the detailed alert, you have to enlarge alert window
       //and double click the alert message
       shift=shift-MathFloor(Period()/TimeFrame);  //speed it up if no bars
       continue;  //we should use return() and force the user to download 
                  //all the charts for his history, but this is painfull and
                  //time consuming, but I am good :D ...  Let the guy compute
                  //the indicator for how many bars he has, even that will
                  //decrease the precision of the indicator, and it will 
                  //take a lot of time when the indicator is initialized
                  //in the beginning and there are a lot of bars to compute
                  //(that is why we try to speed it up by playing with
                  //for counter above and decrement it faster if no history)
     }
     if (!ReverseRing)
     { //suppose we buy a full lot of MainPair (EURUSD here)
       //then how much USD we spent? The quotation on InterbanFX (my broker) 
       //on Metatrader4 accounts shows the Bid prices, and on Metatrader3.8
       //accounts shows the medium prices, so for MT3 one has to change next 
       //lines to add/substract the half of spread in each direction. As we 
       //use here MT4, there will be the spread add to every buy, and no 
       //spread add to the sells. As we do not have a history of the spread, 
       //we will consider Market spread (i.e for E/U is 2 pip 90% of the time,
       //IBFX is one of the best brokers from the spreads point of view, but
       //there were times as June 29, 2006 when the spread was 20pips on E/U!!)
       double GotEUR=100000;
       double SpentUSD=GotEUR*open1+MarketInfo(MainPair,MODE_SPREAD);

       //ok, now we have to buy the same amount of USD by selling GBP
       //at the bid price of GBPUSD pair for the Open on TF=TimeFrame bar.
       //there is no spread when we sell, as MT4 history keeps the bid price
       //but the pair is reverted so we will spend a less amount of GBP
       double SpentGBP=SpentUSD/open2;

       //last, we have to close the ring by selling our EUR back and get GBP
       //there is no spread when we sell, as the history keeps the bid price
       double SpentEUR=SpentGBP/open3;

       //so, we bought GotEUR euro and spent SpentEUR euro. The report is the 
       //value of the indicator, that we will display on the graph. For ideal
       //situation when there is no spread, this report will be 1.00 but here 
       //is like the value will be smaller because of the spread, so the 
       //median line is not at 1.00, but lower. Anyhow, we can only make profit 
       //if we open the ring when the value of indicator is under mean line 
       //(repeat: this is under 1.00 the most of the time) and close it when
       //the indicator is over mean line (can be below 1, but must be over 
       //mean line, that - again - is under 1!. Ideal could be that we close it 
       //when the indicator is over 1.00, but that situation in real time will
       //happen VERY seldom!. Note that we can also make a small profit if we
       //open a ring when the indicator is over 1.00 and close it immediately, 
       //so we got more Euro than we sold. That is what the most arbitrators do
       //but this is unlikely to bring any profit to us as small traders. To
       //be able to profit from that, you must have almost-zero spreads and
       //be able to trade bilions in very small fraction of time. There is yet
       //no broker on the market to sell you this service

       int index=MathFloor(shift*TimeFrame/Period());
       //just for displaying purposes, when the computed period is 
       //more accurate then showing period, we do EMA (integral) averaging. 
       //This helps to see the indicator on the screen more smooth and accurate.
       //If TimeFrame is equal with current time frame, then no averaging will
       //be done, as there is only one value per bar (the Open value)
       if (ExtMapBuffer1[index]==0 || ExtMapBuffer1[index]==EMPTY_VALUE) 
         ExtMapBuffer1[index]=GotEUR/SpentEUR;  //avoid averaging of initial value
       else  ExtMapBuffer1[index]=(ExtMapBuffer1[index]+GotEUR/SpentEUR)/2;
     }  
     else  //reverse ring, we do the same stuff viceversed
     {     //and now we have the spread two times
       SpentEUR=100000;    //here we sell the euro and buy the others
       double GotUSD=SpentEUR*open1;
       double GotGBP=GotUSD/(open2+MarketInfo(SecondPair,MODE_SPREAD));
       GotEUR=GotGBP/(open3+MarketInfo(ThirdPair,MODE_SPREAD));
       
       index=MathFloor(shift*TimeFrame/Period());
       if (ExtMapBuffer1[index]==0 || ExtMapBuffer1[index]==EMPTY_VALUE) 
         ExtMapBuffer1[index]=GotEUR/SpentEUR;  //avoid averaging of initial value
       else  ExtMapBuffer1[index]=(ExtMapBuffer1[index]+GotEUR/SpentEUR)/2;
     }
     
   } //for (shift..)

//for the last bar, that is not closed yet, we compute the indicator 
//for last tick price, that is Close price of the current bar, i.e.
//the indicator is getting more accurate when let running on the chart 
//for a long period of time. The last bar is all the time accurate

   double close1=Close[0];
   double close2=iClose(SecondPair,Period(),0);
   double close3=iClose(ThirdPair,Period(),0);
   if (close1==0 || close2==0 || close3==0)
   { Alert("OOOOPPPSSS! This should not be! Check your pairs!",
     "\n ",MainPair," = ",close1,
     "\n ",SecondPair," = ",close2,
     "\n ",ThirdPair," = ",close3);
     return(0);
     //if you get this alert here, maybe you need to check if your pairs need
     //to have "m" at the end, or maybe (up to your broker) you need to open 
     //the other two charts for the same timeframe in background, for example 
     //you have the indicator on EURUSD M30, then you have to open in 
     //background also the charts for EURGBP M30 and GBPUSD M30, to get the 
     //ticks in real time. You don't need to remove the indicator, just open 
     //the charts and the process will resume
   }
   if (!ReverseRing)
   { GotEUR=100000; //same idea as above
     SpentUSD=GotEUR*close1+MarketInfo(MainPair,MODE_SPREAD);
     SpentGBP=SpentUSD/close2;
     SpentEUR=SpentGBP/close3;
     ExtMapBuffer1[0]=GotEUR/SpentEUR;
   }  
   else  //reverse ring, we do the same stuff viceversed
   {     //and now we have the spread two times
     SpentEUR=100000;    //here we sell the euro and buy the others
     GotUSD=SpentEUR*close1;
     GotGBP=GotUSD/(close2+MarketInfo(SecondPair,MODE_SPREAD));
     GotEUR=GotGBP/(close3+MarketInfo(ThirdPair,MODE_SPREAD));
     ExtMapBuffer1[0]=GotEUR/SpentEUR; 
   }
//Note: We computed here the indicator having the EUR as base curency as
//it has a "medium" price. If we use USD as base curency, the range of the 
//indicator could be 1.2 times larger, and if we use GBP then the range 
//would be 0.6 times (it will stay around 1.00 but it will vary more or less
//around the median, the same efect can be achieved if we modify the 
//indicator_minimum and _maximum properties, so we don't need to stick
//to USD). We use EUR as an average, avoiding to get false positive
//or negative signals. However, the profit below will be computed in USD,
//as that is the base curency for the most of the traders
//end Note

//check if the user moved the profit line, and move the dots with it
//also keep the profit line on the open pices of the graphic
   int begShift=iBarShift(Symbol(),0,ObjectGet("ProfitLine",OBJPROP_TIME1),false);
   int endShift=iBarShift(Symbol(),0,ObjectGet("ProfitLine",OBJPROP_TIME2),false);
   ObjectSet("ProfitLine",OBJPROP_PRICE1,Open[begShift]);

//Later update: if the shift on the right side of profitline is 1, then make it 0 !!
//this update I made when I start testing the indicator with an expert advizor, 
//because the line was not moving with the chart and I had to stop the EA all the
//time to move the bar by hand. The advantage is now if you set the line from 
//somewhere in the past (obvoiusly where FPI was unde 1.00) up to the current bar,
//then the line will move and keep with the current bar, when the new bar is
//opened. So, you can set the green-dot-side in the past, where FPI was very low,
//then set the red-dot-side to the current bar, and you see the profit on the comment
//area and wait until FPI is enough high (and the profit too) then close all the 
//(eventual) trades and book the profit. The disadvantage is that now, you can not
//set the red-dot-side of the line to the previous bar, because it will move to 
//the current bar when first tick come, but this is not really important
   if (endShift==1)
   { endShift=0;
     ObjectSet("ProfitLine",OBJPROP_TIME2,Time[0]);
   }
//end of Later update

   if (endShift==0) //if there is the current bar, we move the line with the 
                    //clossing price. I don't know what will happen if we drag the
                    //line outside of the graphic (in the future). Some error 
                    //should rise, that have to be considered, but this is not
                    //important for this demo. Please do not drag the yellow 
                    //profitline to the future :D, it can not guess your future
                    //profits :P (I think the line will stay with the Close price,
                    //because I am not going to set any "time" for the line, 
                    //only to set the price, so if you drag the right side of the
                    //line in the future, the red dot should folow and the line
                    //will keep the time in the future, so if no error is 
                    //rised, this can be used to get rid of the line when she
                    //obstruct the current bar, but calculating the profit in this
                    //situation, I have no idea what result you can get... )
      ObjectSet("ProfitLine",OBJPROP_PRICE2,Close[endShift]);
   else 
      ObjectSet("ProfitLine",OBJPROP_PRICE2,Open[endShift]);
   
   ObjectMove("GrnDot",0,ObjectGet("ProfitLine",OBJPROP_TIME1),
                         ObjectGet("ProfitLine",OBJPROP_PRICE1)); 
   ObjectMove("RedDot",0,ObjectGet("ProfitLine",OBJPROP_TIME2),
                         ObjectGet("ProfitLine",OBJPROP_PRICE2)); 

//NOW THE MOST INTERESTING PART! 
//==============================
//compute the profit for the new profit line and display it as a comment
//on the upper left corner of the main chart. Profit is calculated for 
//ten full lots of main currency (1 Mio USD here) and displayed for both
//directions of the ring. We consider also that (i.e. for IBFX) the smaller 
//amount that can be traded is 0.01 Lots, i.e 1K US for standard, or 100US
//for minis, so we can not make perfect hedging. Some small amount of money
//will be unhedged and we can make some aditional profit/loss, i.e. some 
//cents will be lost or gained by this rounding (depends if price move in 
//the direction of our unhedged curency, or against it). Also we do not 
//consider any swap money here, but this is an important element too:
//some brokers as Marketiva have ZRP and won't give you or take from you
//any swap, some others as FXCM will only charge you (never GIVE you swap)
//unless you have enough money in your account and trade with 10:1 leverage
//only, or so. Generally, if no ZRP involved, playing for swap will not 
//make you profit, unles you make a larger ring, but on that you pay 
//higher spread. 
  string commentString="\nProfit: ";
  if (begShift<endShift) 
    commentString=StringConcatenate(commentString,"(Your tranzaction is backward in time!)");

//get the times of opening and closing the trades (just for clarity of the program)
  datetime TimeOpen=ObjectGet("ProfitLine",OBJPROP_TIME1);
  //and assuming the profit line was not dragged with the mouse in the future,
  // otherwise we can get strange results for the TimeClose (!)
  datetime TimeClose=ObjectGet("ProfitLine",OBJPROP_TIME2);  

//compute the profit in pips for every of the 3 trades
//(this is not related to ring direction or amount of money, but only
//to the time of opening/closing the trade, i.e. to the profit line)

  //closing price depends if is the current bar or not
  if (endShift==0)
  { double p21=close1;
    double p22=close2;
    double p23=close3;
  }
  else
  { p21=iOpen(MainPair,Period(),iBarShift(MainPair,Period(),TimeClose,false));
    p22=iOpen(SecondPair,Period(),iBarShift(SecondPair,Period(),TimeClose,false));
    p23=iOpen(ThirdPair,Period(),iBarShift(ThirdPair,Period(),TimeClose,false));
  }

  //opening price does not depend of the bar shift, is bar's Open price always
  double p11=iOpen(MainPair,Period(),iBarShift(MainPair,Period(),TimeOpen,false));
  double p12=iOpen(SecondPair,Period(),iBarShift(SecondPair,Period(),TimeOpen,false));
  double p13=iOpen(ThirdPair,Period(),iBarShift(ThirdPair,Period(),TimeOpen,false));
  
  //to be easy to understand I will calculate all pip profits as positive amounts
  //in the direction of the trade, so we have a sell profit or a buy profit sepparate
  //we also deduct the spreads from the PipProfits
  int PipProfitBuy1=MathRound((p21-p11)/MarketInfo(MainPair,MODE_POINT))-
                    MarketInfo(MainPair,MODE_SPREAD); 
  int PipProfitBuy2=MathRound((p22-p12)/MarketInfo(SecondPair,MODE_POINT))-
                    MarketInfo(SecondPair,MODE_SPREAD);
  int PipProfitBuy3=MathRound((p23-p13)/MarketInfo(ThirdPair,MODE_POINT))-
                    MarketInfo(ThirdPair,MODE_SPREAD);

  int PipProfitSell1=MathRound((p11-p21)/MarketInfo(MainPair,MODE_POINT))-
                     MarketInfo(MainPair,MODE_SPREAD); 
  int PipProfitSell2=MathRound((p12-p22)/MarketInfo(SecondPair,MODE_POINT))-
                     MarketInfo(SecondPair,MODE_SPREAD);
  int PipProfitSell3=MathRound((p13-p23)/MarketInfo(ThirdPair,MODE_POINT))-
                     MarketInfo(ThirdPair,MODE_SPREAD);

//we compute the PipValues, these are the value of money for a movement of
//one pip for every pair. Here is $10 for EURUSD and GBPUSD and $19.xxx for EURGBP,
//i.e. the actual rates from IBFX. Assuming the most people have USD based accounts,
//we check if the USD is on the right side of the pair (i.e. xxxUSD). In this case
//the PipValue is 10$ per pip per full lot. We have to check all 3 pairs, for the
//case when the user change the pairs, it is not enough to check for EURGBP.
  if (StringSubstr(MainPair,3,3)=="USD")
  {  double PipValue1Sell=10;  //if yes, pair is xxxUSD, one pip worths 10$
     double PipValue1Buy=10;
     double InitialLots=10; //this we need later when we compute the
                            //initial start ammount for the rings
  }
  else  //if not, pair is xxxYYY, so a pip worth 10 YYY curency, we have to
  {     //find the exchange rate between YYY and USD at the closing time, 
        //i.e. the time when we check the profit (red-dot side of profitline)
    string pair=StringConcatenate(StringSubstr(MainPair,3,3),"USD");
    if (MarketInfo(MainPair,MODE_LOTSIZE)<100000) //is it IBFX mini account?
      pair=StringConcatenate(pair,"m");           //add the "m" for mini accounts
    if (endShift==0)
    { PipValue1Sell=10*iClose(pair,Period(),0);   //for buy price we have to pay
      PipValue1Buy=10*(iClose(pair,Period(),0)+   //also the spread when we close
         MarketInfo(pair,MODE_POINT)*             //because price on chart is  
         MarketInfo(pair,MODE_SPREAD));           //the Bid price and we buy YYY
    }                                             //at the Ask price
    else
    { PipValue1Sell=10*iOpen(pair,Period(),endShift);
      PipValue1Buy=10*(iOpen(pair,Period(),endShift)+
         MarketInfo(pair,MODE_POINT)*MarketInfo(pair,MODE_SPREAD));
    }
    if (iOpen(pair,Period(),begShift)!=0) //avoid zero division if wrong pair
      InitialLots=10/iOpen(pair,Period(),begShift); //we need this to start the rings
    if (PipValue1Sell==0 || PipValue1Sell==EMPTY_VALUE) //for the case when the pair 
    {                                           //is not YYYUSD, but it is USDYYY
      pair=StringConcatenate("USD",StringSubstr(MainPair,3,3));
      if (MarketInfo(MainPair,MODE_LOTSIZE)<100000) //is it IBFX mini account?
        pair=StringConcatenate(pair,"m");           //add the "m" for mini accounts
      if (endShift==0)
      { PipValue1Sell=10/iClose(pair,Period(),0);
        PipValue1Buy=10/(iClose(pair,Period(),endShift)+
          MarketInfo(pair,MODE_POINT)*MarketInfo(pair,MODE_SPREAD));
      }
      else
      { PipValue1Sell=10/iOpen(pair,Period(),endShift);
        PipValue1Buy=10/(iOpen(pair,Period(),endShift)+
          MarketInfo(pair,MODE_POINT)*MarketInfo(pair,MODE_SPREAD));
      }  
      InitialLots=10*iOpen(pair,Period(),begShift); //we need this to start the rings
    }

    //we adjust now the PipValue with the Point size, to normalize it in the case
    //we have the point 0.01 (JPY, etc) or 0.0001 (EUR, etc) 
    PipValue1Sell*=10000*MarketInfo(pair,MODE_POINT);
    PipValue1Buy*=10000*MarketInfo(pair,MODE_POINT);
  }

//do the same for second pair
  if (StringSubstr(SecondPair,3,3)=="USD")
  {  double PipValue2Sell=10;
     double PipValue2Buy=10;
  }
  else 
  { pair=StringConcatenate(StringSubstr(SecondPair,3,3),"USD");
    if (MarketInfo(SecondPair,MODE_LOTSIZE)<100000)
      pair=StringConcatenate(pair,"m");
    if (endShift==0)
    { PipValue2Sell=10*iClose(pair,Period(),0);
      PipValue2Buy=10*(iClose(pair,Period(),0)+ 
         MarketInfo(pair,MODE_POINT)* MarketInfo(pair,MODE_SPREAD));
    }
    else
    { PipValue2Sell=10*iOpen(pair,Period(),endShift);
      PipValue2Buy=10*(iOpen(pair,Period(),endShift)+
         MarketInfo(pair,MODE_POINT)*MarketInfo(pair,MODE_SPREAD));
    }
    if (PipValue2Sell==0 || PipValue2Sell==EMPTY_VALUE)
    { pair=StringConcatenate("USD",StringSubstr(SecondPair,3,3));
      if (MarketInfo(SecondPair,MODE_LOTSIZE)<100000)
        pair=StringConcatenate(pair,"m");
      if (endShift==0)
      { PipValue2Sell=10/iClose(pair,Period(),0);
        PipValue2Buy=10/(iClose(pair,Period(),endShift)+
          MarketInfo(pair,MODE_POINT)*MarketInfo(pair,MODE_SPREAD));
      }
      else
      { PipValue2Sell=10/iOpen(pair,Period(),endShift);
        PipValue2Buy=10/(iOpen(pair,Period(),endShift)+
          MarketInfo(pair,MODE_POINT)*MarketInfo(pair,MODE_SPREAD));
      }
    }  
    PipValue2Sell*=10000*MarketInfo(pair,MODE_POINT);
    PipValue2Buy*=10000*MarketInfo(pair,MODE_POINT);
  }

//do the same for the third pair
  if (StringSubstr(ThirdPair,3,3)=="USD")
  {  double PipValue3Sell=10;
     double PipValue3Buy=10;
  }
  else 
  { pair=StringConcatenate(StringSubstr(ThirdPair,3,3),"USD");
    if (MarketInfo(ThirdPair,MODE_LOTSIZE)<100000)
      pair=StringConcatenate(pair,"m");
    if (endShift==0)
    { PipValue3Sell=10*iClose(pair,Period(),0);
      PipValue3Buy=10*(iClose(pair,Period(),0)+
         MarketInfo(pair,MODE_POINT)*MarketInfo(pair,MODE_SPREAD));
    }
    else
    { PipValue3Sell=10*iOpen(pair,Period(),endShift);
      PipValue3Buy=10*(iOpen(pair,Period(),endShift)+
         MarketInfo(pair,MODE_POINT)*MarketInfo(pair,MODE_SPREAD));
    }
    if (PipValue3Sell==0 || PipValue3Sell==EMPTY_VALUE)
    { pair=StringConcatenate("USD",StringSubstr(ThirdPair,3,3));
      if (MarketInfo(ThirdPair,MODE_LOTSIZE)<100000)
        pair=StringConcatenate(pair,"m");
      if (endShift==0)
      { PipValue3Sell=10/iClose(pair,Period(),0);
        PipValue3Buy=10/(iClose(pair,Period(),endShift)+
          MarketInfo(pair,MODE_POINT)*MarketInfo(pair,MODE_SPREAD));
      }
      else
      { PipValue3Sell=10/iOpen(pair,Period(),endShift);
        PipValue3Buy=10/(iOpen(pair,Period(),endShift)+
          MarketInfo(pair,MODE_POINT)*MarketInfo(pair,MODE_SPREAD));
      }
    }
    PipValue3Sell*=10000*MarketInfo(pair,MODE_POINT);
    PipValue3Buy*=10000*MarketInfo(pair,MODE_POINT);
  }

//finished computing of PipValues  
//add the stuff to the comment, just for verification of calculus
  commentString=StringConcatenate(commentString,
     "\n\n PipValues: ",PipValue1Sell,"(",PipValue1Buy,"), ",
                        PipValue3Sell,"(",PipValue3Buy,"), ",
                        PipValue2Sell,"(",PipValue2Buy,")\n");

//start computing the profit
  double BigProfit=0;  //what a nice paradox here :D 
                       //this is the program line that I like most! :P
                       //(the "double" in front of it worth all the money!
                       //looks like we are trying to double our big zero profit) 
                       //I hope you will sense the irony and not take it ad literam

//1.First we buy USD and sell EUR, so the ring is sell/buy/buy (SBB)
  //1.a. We place a bet here at the green/blue circle, and cover at the red circle

  //if our account is in USD, and MainPair is xxxYYY we have to convert 10 lots
  //of USD into YYY, as we work with 10 lots USD all the time, and find how
  //many YYY we need to start the ring. Lateron here I will only refer to USD 
  //for clarity, but in fact is YYY if the user changes the pairs
  GotUSD=InitialLots; //10 lots USD to start this refers to 10 real USD lots,
                      //not YYY, we have a qty of "GotUSD YYY lots" equivalent
                      //of base account 10 USD Lots

  //how many lots of EURUSD we have to sell to get GotUSD lots of USD?
  //we compute the normalized value to 0.01 Lots (minimum trading amount)
  SpentEUR=NormalizeDouble(GotUSD/p11,2); 
  //we calculate the profit/loss, when we close the trade, and deduct the spread
  if (PipProfitSell1>0) //if we have a gain on xxxYYY pair, then we have to 
    //sell our YYY to buy USD and book out the profit, so is hidden sell of YYYUSD
    BigProfit=BigProfit+SpentEUR*PipValue1Sell*PipProfitSell1; 
  else //but if the profit is negative, we have lost a qty of YYY, then we have 
    //to buy YYYUSD and cover our loss (is a hidden buy the broker do when
    //you trade croses, is what Michal does in his example when he convert the 
    //amount of JPY gained, into USD, assuming the base account is in USD)
    BigProfit=BigProfit+SpentEUR*PipValue1Buy*PipProfitSell1; 

  //1.b. need to get back our EUR, by selling GBP, so we buy SpentEUR qty of EURGBP
  //we calculate the profit/loss, when we close the trade, and deduct the spread
  if (PipProfitSell3>0) //same as above idea
    BigProfit=BigProfit+SpentEUR*PipValue3Sell*PipProfitBuy3;
  else
    BigProfit=BigProfit+SpentEUR*PipValue3Buy*PipProfitBuy3;
  
  //1.c. how many lots of GBP we sold for the last tranzaction?
  //we compute the normalized value to 0.01 Lots (minimum trading amount)
  SpentGBP=NormalizeDouble(SpentEUR*p13,2); 

  //we need to get back our GBP by selling USD, so we buy SpentGBP qty of GBPUSD
  if (PipProfitSell2>0) //same as above idea
    BigProfit=BigProfit+SpentGBP*PipValue2Sell*PipProfitBuy2;
  else
    BigProfit=BigProfit+SpentGBP*PipValue2Buy*PipProfitBuy2;

  //end of first (direct) ring
  //so, THAT was a perfect hedging, not what is on the first page of the forum

  //now just for checking and display it in the comment, we compute how many
  //USD we sold. This is not important for calculus, but just for verifying,
  //if this qty is larger then 10 lots, the profit should be negative, because
  //at the end, when we count the money, we sold more USD then we initialy bought
  //(that is theoretically, see below how is it practically :D)
  SpentUSD=SpentGBP*p12; //this no need to be normalized, we closed the ring
  int USDDifference=(GotUSD-SpentUSD)*MarketInfo(Symbol(),MODE_LOTSIZE);
  
  //now we upgrade the comment with all the info we have
  //THIS IS VERY INSTRUCTIVE !!! you can see that even if we have a perfect hedge
  //and even if we make sometime a POSITIVE profit in PIPS, and also we make 
  //sometimes a POSITIVE income in USD qty, i.e. we got back more USD than we 
  //invested) however, the profit in ***MONEY**** could be NEGATIVE!!! Why???
  //That is not because of the spreads! (spreads are already included in the pip
  //profit calculation), but it come from the pip VALUES. You got some USD in your
  //pocket, by seling 100 and having back 103 after the ring closed, but the value
  //of the USD in the ring decreased. There is a false idea that you can make 
  //enough profit to cover the spread from this kind of hedging. If you 
  //compute everything with spreads ZERO, you will also get a loss! 
  //This is a bit conter-intuitive, but is the reality, it is mathematic!
  //Everytime you have a profit, if it was not 9/11/2001, then you beter check 
  //your hedging. There could be some amount of money unhedged, for sure!
  //You can find some oportunity to make profit from "perfect" hedging, but
  //this is VERY rarely, you have to involve bilions to make it worth.
  //The situation Michal describe in his example is such an special ocasion, 
  //if you chech the liquidity an that date, it was extremely low, and the 
  //spread of IBFX was 12pips for EURUSD on that date!!!! This is not a joke!
  commentString=StringConcatenate(commentString,
          "\nDirect Ring Profit $: ",BigProfit,", USD got: ",USDDifference,
          "\n  ",MainPair,": Sold=",SpentEUR,", Bought=",GotUSD,"  @ Pips: ",PipProfitSell1,
          "\n  ",ThirdPair,": Bought=",SpentEUR,", Sold=",SpentGBP,"  @ Pips: ",PipProfitBuy3,
          "\n  ",SecondPair,": Bought=",SpentGBP,", Sold=",SpentUSD,"  @ Pips: ",PipProfitBuy2);


//2.Second we sell USD and buy EUR, so the ring is buy/sell/sell (BSS)
  BigProfit=0;  //we reuse variables (not so nice as with "double" in front :P)

  //We place a bet here at the green/blue circle, and cover at the red circle
  SpentUSD=InitialLots; //10 lots to start

  //how many lots of EURUSD can we buy, by selling SpentUSD lots of USD?
  //we compute the normalized value to 0.01 Lots (minimum trading amount)
  GotEUR=NormalizeDouble(SpentUSD/p11,2); 
  //we calculate the profit/loss, when we close the trade, and deduct the spread
  if (PipProfitSell1>0) //same as above idea
    BigProfit=BigProfit+GotEUR*PipValue1Sell*PipProfitBuy1; 
  else  
    BigProfit=BigProfit+GotEUR*PipValue1Buy*PipProfitBuy1; 

  //we sell our EUR and buy GBP, so we sell GotEUR qty of EURGBP
  //we calculate the profit/loss, when we close the trade, and deduct the spread
  if (PipProfitSell3>0) //same as above idea
    BigProfit=BigProfit+GotEUR*PipValue3Sell*PipProfitSell3;
  else
    BigProfit=BigProfit+GotEUR*PipValue3Buy*PipProfitSell3;

  //how many lots of GBP we got from the last tranzaction?
  //we compute the normalized value to 0.01 Lots (minimum trading amount)
  GotGBP=NormalizeDouble(GotEUR*p13,2); 

  //we sell our GBP and buy USD, so we sell GotGBP qty of GBPUSD
  if (PipProfitSell2>0) //same as above idea
    BigProfit=BigProfit+GotGBP*PipValue2Sell*PipProfitSell2;
  else
    BigProfit=BigProfit+GotGBP*PipValue2Buy*PipProfitSell2;

  //now just for checking and display it in the comment, we compute how many
  //USD we got. This is not important for calculus, but just for verifying,
  //if this qty is smaller then 10 lots, the profit should be negative, because
  //at the end, when we count the money, we got less USD then we initialy sold
  GotUSD=GotGBP*p12;  //this no need to be normalized, we closed the ring
  USDDifference=(GotUSD-SpentUSD)*MarketInfo(Symbol(),MODE_LOTSIZE);
  
  //now we upgrade the comment with all the info we have for reverse ring

  Comment(commentString,
          "\n\nReverse Ring Profit $: ",BigProfit,", USD got: ",USDDifference,
          "\n  ",MainPair,": Bought=",GotEUR,", Sold=",SpentUSD,"  @ Pips: ",PipProfitBuy1,
          "\n  ",ThirdPair,": Sold=",GotEUR,", Bought=",GotGBP,"  @ Pips: ",PipProfitSell3,
          "\n  ",SecondPair,": Sold=",GotGBP,", Bought=",GotUSD,"  @ Pips: ",PipProfitSell2);

//---- ALL DONE, take a break! Plenty of work for just showing how "profitable"
//---- is this strategy in real time..... :D
   return(0);
  }
//+------------------------------------------------------------------+